/*
 * ExportGraph.hpp
 *
 *  Created on: 08.03.2012
 *      Author: heber
 */

#ifndef EXPORTGRAPH_HPP_
#define EXPORTGRAPH_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Fragmentation/Graph.hpp"

/** ExportGraph is an interface definition of a class that takes a fragmented
 * system contained in an instance of Graph and exports it to some place else.
 *
 * Guidelines are as follows:
 * - all derived classes should have their specific properties set by extra
 *   setters and not by passing them through the cstor
 * - operator() is called without arguments.
 */
class ExportGraph
{
public:
	ExportGraph(const Graph &_graph);
	virtual ~ExportGraph();

	virtual void operator()()=0;

protected:
	const Graph &TotalGraph;
};

#endif /* EXPORTGRAPH_HPP_ */
